#encoding:utf-8
import re
from django.http import HttpResponseRedirect
from django.shortcuts import render_to_response
from django.template import RequestContext
from apps.login.forms import *
from django.contrib.auth import authenticate,login,logout
from django.contrib.auth.models import User

# create a function to resolve email to username
def get_user(email):
	try:
		return User.objects.get(email=email.lower())
	except User.DoesNotExist:
		return None

def login_auth(request):

	next = ""
	state = ""

	if request.GET:  
		print request.GET["next"]
	        next = request.GET['next']

	if request.POST:
		#obtener posible email
		username = request.POST["username"]
		password = request.POST["password"]

		if re.match(r"^[A-Za-z0-9\.\+_-]+@[A-Za-z0-9\._-]+\.[a-zA-Z]*$",username ):
		#se trata de un correo
			email = username
			username = get_user(email)

		user = authenticate(username = username , password = password)
 

		if user is not None:
			#Si esta logeado el usuario
			login(request, user)

		        return HttpResponseRedirect(next)
		else:
			state = "Clave , email o usuario incorrecto"

	ctx = { "login_form" : LoginForm, 
		"state" : state ,
		'next':next
	}	
	return render_to_response('login/login.html',ctx,  context_instance = RequestContext(request)  )

#Cerrar sesion
def logout_auth(request):
    logout(request)
    return HttpResponseRedirect('/')
