from django.db import models
from django.contrib.auth.models import User


class Status(models.Model):
    tipo = models.CharField(max_length=50)
    class Meta:
        db_table = u'status'


class Pregunta(models.Model):
    folio = models.CharField(max_length=300)
    creacion = models.DateTimeField(auto_now_add = True)
    pregunta = models.TextField(blank=True)
    informacion = models.TextField(blank=True)
    status_id = models.ForeignKey(Status , db_column = "status_id")
    de = models.ForeignKey(User , related_name= "de")
    para = models.ForeignKey(User , related_name="para")
    class Meta:
        db_table = u'pregunta'
    
    #metodo para obtener el ultimo folio , incrementarlo y guardar la pregunta con el folio incrementado
    def save(self):
	try:
    		last = Pregunta.objects.order_by('-folio')[0]
		self.folio = int(last.folio)+1
	except:
		self.folio = 1

	super(Pregunta , self).save()
   
class PreguntaCc(models.Model):
    pregunta_id = models.ForeignKey(Pregunta , db_column = "pregunta_id")
    #pregunta CC es el ForeignKey del User
    pregunta_cc = models.ForeignKey(User , db_column = "pregunta_cc")
    class Meta:
        db_table = u'pregunta_cc'

class Respuesta(models.Model):
    creacion = models.DateTimeField( auto_now_add = True )
    respuesta = models.TextField(blank=True)
    user_creador = models.ForeignKey(User)
    pregunta_id = models.ForeignKey(Pregunta)
    class Meta:
        db_table = u'respuesta'
