

CREATE SCHEMA IF NOT EXISTS `pinf` DEFAULT CHARACTER SET utf8 COLLATE utf8_spanish_ci ;
USE `pinf` ;

-- -----------------------------------------------------
-- Table `pinf`.`status`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`status` ;

CREATE TABLE IF NOT EXISTS `pinf`.`status` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `pendiente` INT NULL,
  `cancelado` INT NULL,
  `urgente` INT NULL,
  `respondido` INT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`pregunta`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`pregunta` ;

CREATE TABLE IF NOT EXISTS `pinf`.`pregunta` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `folio` VARCHAR(100) NOT NULL,
  `creacion` DATETIME NULL,
  `pregunta` LONGTEXT NULL,
  `informacion` LONGTEXT NULL,
  `status_id` INT NOT NULL,
  `de` INT NOT NULL,
  `para` INT NOT NULL,
  PRIMARY KEY (`id`, `status_id`, `para`, `de`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`feed`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`feed` ;

CREATE TABLE IF NOT EXISTS `pinf`.`feed` (
  `feed` INT NOT NULL,
  PRIMARY KEY (`feed`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`rol`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`rol` ;

CREATE TABLE IF NOT EXISTS `pinf`.`rol` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nombre` VARCHAR(50) NULL,
  `crear` INT NULL,
  `ver` INT NULL,
  `modificar` INT NULL,
  `eliminar` INT NULL,
  PRIMARY KEY (`id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`settings`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`settings` ;

CREATE TABLE IF NOT EXISTS `pinf`.`settings` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nombre` TEXT NULL,
  `img` VARCHAR(100) NULL,
  `creacion` DATETIME NULL,
  `rol_id` INT NOT NULL,
  `email` VARCHAR(100) NULL,
  `password` VARCHAR(100) NULL,
  PRIMARY KEY (`id`, `rol_id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`usuario`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`usuario` ;

CREATE TABLE IF NOT EXISTS `pinf`.`usuario` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `settings_id` INT NOT NULL,
  PRIMARY KEY (`id`, `settings_id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`organizaciones`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`organizaciones` ;

CREATE TABLE IF NOT EXISTS `pinf`.`organizaciones` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `nombre_organizacion` TEXT NULL,
  `creacion` DATETIME NULL,
  `usuario_creador` INT NOT NULL,
  PRIMARY KEY (`id`, `usuario_creador`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`organizaciones_has_usuario`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`organizaciones_has_usuario` ;

CREATE TABLE IF NOT EXISTS `pinf`.`organizaciones_has_usuario` (
  `organizaciones_id` INT NOT NULL AUTO_INCREMENT,
  `usuario_miembro` INT NOT NULL,
  PRIMARY KEY (`organizaciones_id`, `usuario_miembro`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`respuesta`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`respuesta` ;

CREATE TABLE IF NOT EXISTS `pinf`.`respuesta` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `creacion` DATETIME NOT NULL,
  `respuesta` LONGTEXT NULL,
  `usuario_creador` INT NOT NULL,
  `pregunta_id` INT NOT NULL,
  PRIMARY KEY (`id`, `usuario_creador`, `pregunta_id`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`suscripcion`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`suscripcion` ;

CREATE TABLE IF NOT EXISTS `pinf`.`suscripcion` (
   `id` INT NOT NULL AUTO_INCREMENT,
  `suscriptor` INT NOT NULL,
  `suscrito_to` INT NOT NULL,
  PRIMARY KEY (`id`, `suscriptor`, `suscrito_to`))
ENGINE = InnoDB;


-- -----------------------------------------------------
-- Table `pinf`.`pregunta_cc`
-- -----------------------------------------------------
DROP TABLE IF EXISTS `pinf`.`pregunta_cc` ;

CREATE TABLE IF NOT EXISTS `pinf`.`pregunta_cc` (
  `id` INT NOT NULL AUTO_INCREMENT,
  `pregunta_id` INT NOT NULL,
  `pregunta_cc` INT NOT NULL,
  PRIMARY KEY (`id`, `pregunta_id`, `pregunta_cc`) )
ENGINE = InnoDB;

 
