define([
'jquery',
'backbone',
'underscore',
'create_user',
'setting_model',
'setting_template',
], function( $ , Backbone , _  , CreateUserButton , setting_model , setting_template){

	Directory_contacts = {

		Models : {},
		Views : {},
		Collections : {},

	}

return (function(){
	//---------------------------------------------------------------------------------------------------------------------- MODEL and Collection
	
	Directory_contacts.Models.Contacts = Backbone.Model.extend({});


	
	// si eres admin puedes ver todos los usuarios , si no , solo los que estas suscrito

	var  url_to_get_users = "";
	if(config_user.is == 	"Admin" ){
		
		url_to_get_users = "/api/v1/usuario/";
	}else{

		url_to_get_users = 'api/v1/allow_contacts/?user_suscriptor='+config_user.id;
	}

	

	Directory_contacts.Collections.Directory = Backbone.Collection.extend({

		url : url_to_get_users,

		model: Directory_contacts.Models.Contacts ,// Cotacts is a model

		initialize : function(){


		}
		,parse: function(response) {
			return response.objects;
}
	});

	//---------------------------------------------------------------------------------------------------------------------- VIEW
	//contact 1:1

	var  Contact  = Backbone.View.extend({

		tagName : "div",

		className :"contact-str",

		template_contact : $("#template-contact").html() , 

		render : function(){

				// this.model.toJSON enviamos el item desde la vista padre ( mirar abajo ) para render each user
				/*  this.model.toJSON()  , { contact : this.model.toJSON() }*/ 
				
				var view_contact = _.template(this.template_contact  ,  this.model.toJSON()  );
				this.$el.html(view_contact);
				return this;	
			
		}

	});

	// Vista de todos los contactos , se renderea cada contacto en una lista 

		

	Directory_contacts.Views.Contacts_directory = Backbone.View.extend({


		el : ".container-contants" , 


		initialize  : function(){

			that = this;
			// creamos un nueva nueva coleccion y ponemos as escuhar a la coleccion cuando se anada otro modelo
			Directory_contacts.Collections.current_collection = new Directory_contacts.Collections.Directory();
			Directory_contacts.Collections.current_collection.on('add', this.preappend_new_contact, this);
			this.render();
			
			if(config_user.is == "Admin"){
			var create_button_user = new CreateUserButton(); 
			var rendered_button =   create_button_user.render().el; 
			$(".create_user_container").html(rendered_button);
			}

			if ( $("body").data("contact_instance") == undefined || $("body").data("contact_instance").events  == false){

				$(".container-contants" ).on("click",".contact-str" , this.get_setting_user);
				$("body").data({ "contact_instance" : {  events : true }  } );
			}

			var $search_input =$(".search-contact input");		
			$search_input.keyup(this._filter_contact );
			$search_input.val("");
			Directory_contacts.Collections.current_collection.on("reset", this.update_models_in_controllers , this);
			$('body').data({ "saved_model": { 'is_saved' : false , 'models' : false } });

		}, 
		_filter_contact  : function(e){
				
				//salvamos los modelos completos , todos los modelos originales
				if ( !$('body').data("saved_model").is_saved ){
					
					$('body').data("saved_model").models = Directory_contacts.Collections.current_collection.models
					$('body').data("saved_model").is_saved = true;
				}

				var value = $(e.currentTarget).val().toLowerCase().trim();
	 
	 			models = $('body').data("saved_model").models 

	 			filtered_models = _.filter( models , function(item){
		    
					var name_complete = item.get("first_name").toLowerCase() +" "+item.get("last_name").toLowerCase();
					return name_complete.indexOf(value) !== -1;
			   
	 			});

	 			Directory_contacts.Collections.current_collection.reset(filtered_models)
	  

		},
		get_setting_user : function(){
			

			var current_id = $(this).find(".name").attr("data-id");

			console.log(current_id);

			that.model = new setting_model();			
			that.model.set("id" , current_id );
			
			that.model.fetch({
			beforeSend : function(){
				
			$("#loader").show();

				},
			
			success : function(settings , res ){
				
				$("#loader").hide();

			console.log(res )	

			var template_setting = new setting_template({

				model : that.model

			});


			template_setting = template_setting.render().el;

				$(".content-setting-user").html(template_setting);
				
				$(".timeago").timeago();

				}
			});


		},
		preappend_new_contact : function(){
	
			var length_collection = Directory_contacts.Collections.current_collection.length;
			var collection_length = Directory_contacts.Collections.current_collection.length
			var last_model = Directory_contacts.Collections.current_collection.at(collection_length-1)

			var contactView  = new Contact({
				model :last_model	
			});

			this.$el.prepend(contactView.render().el );

		},
		update_models_in_controllers : function(){
					
				this.$el.html("");
				var that =this ;
				_.each (Directory_contacts.Collections.current_collection.models , function(contact_item){
					
					that.renderContact(contact_item);
				});

		},
		render : function(){

		var that = this;
		Directory_contacts.Collections.current_collection.fetch({

			beforeSend  : function(){
				that.$el.html(""); // empty container contacts
				$("#loader").show();

			},
			success : function(data){
							
				that.update_models_in_controllers();

				$("#loader").hide();

				}
			});		
			
	}, 

		renderContact : function(contact_item){

			
			var contactView  = new Contact({
				model :	contact_item 
			});

			this.$el.append(contactView.render().el );
		}
	});//end master view


	return  Directory_contacts.Views.Contacts_directory 
})($, _ ,Backbone  );

});
