define( function(require){
	
return (function(){
	
	var $		= require('jquery'),
	    _ 		= require('underscore'),
	    Backbone    = require('backbone');


// modelos para crear nuevo usuario

	var model_new_user = Backbone.Model.extend({
		
		url : '/api/v1/newuser/',

		defaults: {
		
		username : "",
		password : "",
		first_name : "",
		last_name : "",
		email : "",
		rol : "",
	}

		});

// boton de "crear usuario" , que prepara todos los datos , los inserta al modelo creando un nuevo modelo , y da save al modelo
// boton de click para crear nuevo usuario

	var create_user_button  = Backbone.View.extend({

		 el : ".send_new_user",

		 initialize : function(){
			_.bindAll(this,"check_all_fields_populated");
			_.bindAll(this,"create_new_user");
			_.bindAll();
			$("#rol_button span").click(function(){
				
				
				var $current = $(this);
				var selected_rol = $current.html();
				
				var data_selected =  $current.attr("data"); 
				$(".btn-rol-user").html(selected_rol)
						  .attr("data" , data_selected);


			});
		 },

		 // referencia al contenedor de los datos del nuevo usuario ( inpu)
		 container_user_form : $(".content-info-user input") ,

		 events : {

			 "click" : "create_new_user",

		 },

		 create_new_user : function(){


				this.check_all_fields_populated();

				

		 },
		 // checamos que inputs ya tienen datos y si son validos , si no hay datos ponemos borde rojo
		 check_all_fields_populated : function(){
			
			

			var container_user_form =  $(".content-info-user input");

			// checamos si todos los campos estan llenos

			_.each( container_user_form  , function(input){

			 var	input =  $(input)				
				

				input.removeClass("wrong_field");
				if ( input.val().trim().length <= 1 ){
						
						input.addClass("wrong_field");
				}

			});

			//checamos si las claves son indenticas 	
			var password1 = container_user_form.filter(".password_1")
			var pass1_value = password1.val()
			 
			var password2 = container_user_form.filter(".password_2")
			var pass2_value = password2.val()
			   
			if ( pass1_value  ==  pass2_value  && pass1_value.length > 3 && pass2_value.length  >3  ){
					password1.removeClass("wrong_field");
					password2.removeClass("wrong_field");
			}else{

					password1.addClass("wrong_field");
					password2.addClass("wrong_field");
				}

			// checamos si el email es valido

			var email = container_user_form.filter("[match=email]");
			is_valid  = this.validateEmail(email.val().trim() );
			if (!is_valid){

				email.addClass("wrong_field");
			}else{
				email.removeClass("wrong_field");

			}
			
			
			// ahora chearemos si hay campos invalidos  y retornaremos true si es valido el form , falso si hay erroes
			
			 var wrong_fields  = container_user_form.filter(".wrong_field")
			  
			  var is_validate =  ( wrong_fields.length > 0 ) ? false : true

			// SELECCION DEL ROL DE USUARIO

			var button_rol = $(".btn-rol-user");
			var id_rol = button_rol.attr("data");

			  var is_selected_rol =  ( id_rol == undefined || id_rol == ""  ) ? false : true
			
			if(!is_selected_rol){
				 button_rol.addClass("wrong_field");	
			}else{

			 button_rol.removeClass("wrong_field");	
			}


			// ENVIA DATOS

			  if(is_validate && is_selected_rol){
	
			 var first_name = container_user_form.filter(".first-name").val().trim();
			 var last_name = container_user_form.filter(".last-name").val().trim();

				var new_model_user   =  new model_new_user();
				var name_lastname = first_name+" "+last_name
				var create_username = name_lastname.toLowerCase().split(' ').join('_')
				new_model_user.set("username",  create_username );
				new_model_user.set("password", password1.val()  );
				new_model_user.set("first_name", first_name  );
				new_model_user.set("last_name", last_name );
				new_model_user.set("email", email.val().trim()  );
				new_model_user.set("rol", id_rol );
		
				/*username : "",
				password : "",
				first_name : "",
				last_name : "",
				email : "",
				rol : "",
				*/
				
				
				new_model_user.save(null  , {
					
					success : function(model , data){

						
						
						
						$(".message-notify-error").hide();

						// update a la collection que tiene los contactos
						var new_contact_model = new Directory_contacts.Models.Contacts();
						
						new_model_user.set(data);
						Directory_contacts.Collections.current_collection.add(new_model_user);
						// Directory_contacts.Collections.current_collection esta declarado en conactos/contact.js y contiene los datos actuales

						$(".close_button").click();
					},
					error : function(data, response){

						
						var responseObj = $.parseJSON(response.responseText)	
						
						$(".message-notify-error").show();
						$(".message-notify-error").html(responseObj.error);
					}
				});

				
			  }else{

				
			  }
			   

		 },
		 validateEmail : function(email) { 

			 // http://stackoverflow.com/a/46181/11236
			   
			       var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
			           return re.test(email);
		 } 
	});
// Manejo de la interface de la modalbox , todo el form 
	var create_user = Backbone.View.extend({

		template  : $("#template-create-user").html(),
		
		content : $("#template-create-user-form").html() , 

		footer : $("#template-buttons-create").html() , 

		initialize : function(){

			
		},
		render : function(){
			
			var button_template = _.template(this.template );
			this.$el.html(button_template);
			return this;
		},
		events : {

			"click" : "create_user_modal",
		},
		create_user_modal : function(){

			var that = this;
			
			$.modal({

				title : "Crear nuevo usuario",
				content : that.content , 
				footer : that.footer,
			});

			new create_user_button();

		}
	})

	return create_user;

	})(); // end callback

})
