define( function(require){

return (function(){

	var $		= require('jquery'),
	    _ 		= require('underscore'),
	    Backbone    = require('backbone'),
	    instance_question 	= require('question_timeline'),
	    filters 	= require('filters'),
	    paginator 	= require('paginator'),
	    timeago 	= require('timeago');
	

var Timeline  = {
		Models 		: {},
		Collections 	: {},
		Views 		: {}

	}
//------------------------------------------------------------------------------------------------------------------------------- MODEL COLLECTION
	Timeline.Models.Question = Backbone.Model.extend({});

	Timeline.Collections.Questions = Backbone.Collection.extend({

		url : 'api/v1/timeline/?user_id='+config_user.id,

		model : Timeline.Models.Question,

		initialize : function(){

		},
		
		parse : function(response){
			console.log(response , "=======>");
			this.next = response.meta.next;
			this.total_count = response.meta.total_count;
			this.limit = response.meta.limit;
			this.offset = response.meta.offset;

			return response.objects;

		}
		});

//------------------------------------------------------------------------------------------------------------------------------- VIEW

	//MASTER VIEW
	Timeline.Views.dashboard = Backbone.View.extend({

		el : ".container_questions",

		initialize : function(){
			
	
		Timeline.Collections.Question = new Timeline.Collections.Questions()
		Timeline.Collections.Question_paginator = new Timeline.Collections.Questions()
		this.render();

		this.reset_html_paginator();

		config_user['path'] = 'dashboard'
		config_user['slice_name'] = false;
		config_user["uri_status_question"] =  undefined;

		},
		reset_html_paginator : function(){

		$(".content-questions-stream .no_response").remove();
		$(".paginator-question").remove();

		},
		append_new_questions_by_paginator : function(){


				var new_url_to_paginate = $(".paginator-question .url-next").attr("next"); 

				console.log("append new questions now ");

				Timeline.Collections.Question_paginator.url =   new_url_to_paginate;

				Timeline.Collections.Question_paginator.fetch({

				beforeSend  : function(){
		
					$("#loader").show();

				},

				success : function(data){
								
					console.log(data.models)
					console.dir( Timeline.Collections.Question_paginator)
					Timeline.Collections.Question.add(data.models )
					

					_.each (data.models , function(question_item){
						that.renderQuestion(question_item);

					});

					$("#loader").hide();
					$(".timeago").timeago();

			
					//decide si agregar el paginator de laas preguntas o no
					that.if_append_paginator(data);

					}	
			});
		},
		if_append_paginator : function(data){

				// si el total de las preguntas es mayor que el limite entonces procedemos a sacar las preguntas
				//data.total_count es la cantidad total de las preguntas existentes

				console.log(Timeline.Collections.Question.models.length)
				$(".paginator-question").remove();
				console.log(data.total_count , Timeline.Collections.Question.models.length );
				if ( data.total_count >  Timeline.Collections.Question.models.length ){

						console.log("ahhhh ======>" , data.total_count , data.limit);
						paginator_template = new paginator();
						// antes de llamar a template ponemos nuevas configuraciones al template

						// apuntamos la nueva ruta de paginacion
						paginator_template.next_url = data.next;

						// apuntamos la nueva callback a exec
						paginator_template.callback =  this.append_new_questions_by_paginator;

						//ingresamos el el template el nuevo paginador
						var template_paginator = paginator_template.render().el;
						$(".container[data=dashboard] .content-questions-stream").append(template_paginator);
				}else{


					that.reset_html_paginator();
					console.log("fin");
					$(".container[data=dashboard] .content-questions-stream").append("<div class='no_response'> No hay mas preguntas y pendientes. </div>");
					this.paginator = false;

				}

		},


	// cada ves que se dispara un evento se actualiza el timeline 

		update_timeline : function(){
		console.log("timeline");	
			that.reset_html_paginator();
			// uri_status ya contiene la cadena exacta que se va a agregar al final de la url 
			var uri_status_question = config_user.uri_status_question;

			console.log(uri_status_question)
			//regresamos la path a su estado original

			//uri_status_question es la url que se anarida al final de la url para poder filtrar las preguntas
			// si es la primera ves que se ejecuta este metodo entonces no esta definido uri_status_question y la url esta intacta
			if (uri_status_question == undefined){

				//backup original url
				path_url_original = Timeline.Collections.Question.url;
				//uri_status_question is undefined , so put it ""
				uri_status_question = "";

			}else{
				// seunda ves que se ejecuta el metodo entonces reestablecemos la url para evitar que se acumulen parametros de uri_status
				Timeline.Collections.Question.url = path_url_original;	
			}
			

			Timeline.Collections.Question.url = Timeline.Collections.Question.url+ uri_status_question;

		 	Timeline.Collections.Question.fetch({

			beforeSend  : function(){
	
				that.$el.html(""); // empty container contacts
				$("#loader").show();

			},
			success : function(data){
							

				that.if_append_paginator(data);
				_.each (data.models , function(question_item){
					that.renderQuestion(question_item);

				});

				$("#loader").hide();
				$(".timeago").timeago();

		

				}	
			});

		},

		render : function(){

		that = this;

		var filter_button_instance = $("body").data("instance_filter");
		var filter_button = "";	

		
		 console.log(filter_button_instance)
		 if ( filter_button_instance == undefined ){
		 
		 var new_instance_filter = new filters();
		 $("body").data("instance_filter" , new_instance_filter  );

		 filter_button = new_instance_filter;

		 }else{

		filter_button  =  $("body").data("instance_filter");

		 }

		
		$(".filters-container").html(filter_button.render().template );

		filter_button.set_callback = this.update_timeline;

		//-----------------------------------------------------

		this.update_timeline();


		}, renderQuestion : function(question){
			
			
			var question_instance = new instance_question({
				model : question 
			});
			
		this.$el.append(question_instance.render().el);

		}
	});


	return Timeline.Views.dashboard;
	
})(require);




	});
