define( function(require){
	var $		= require('jquery'),
	    _ 		= require('underscore'),
	    instance_question 	= require('question_timeline'),
	    filters 	= require('filters'),
	    paginator 	= require('paginator'),
	    Backbone    = require('backbone');
	
return (function(){

	

var		question_release_= {

		Views 		: {},
		Models 		:{},
		Collections 	: {}
		}
//--------------------------------------------------------------------------------------------------------- MODEL COLLECTION

		//MODELS 
		question_release_.Models.timeline = Backbone.Model.extend({});
		
		//Collections

		question_release_.Collections.timeline = Backbone.Collection.extend({

			url : "api/v1/pregunta/?de="+config_user.id,

			initialize : function(){

				

			},
		parse : function(response){

			this.next = response.meta.next;
			this.total_count = response.meta.total_count;
			this.limit = response.meta.limit;
			this.offset = response.meta.offset;

			return response.objects;

		}
		});

	question_release_.Views.question_release = Backbone.View.extend({
	el : ".container_questions",

	main : ".content-question-release" ,

	tab  : ".question-release-link",

	initialize : function(){

		config_user['path'] = 'quesion_release'
		config_user['slice_name'] = false;
		config_user["uri_status_question"] =  undefined;

		this.reset_html_paginator();
		question_release_.Collections.released_questions = new question_release_.Collections.timeline();
		question_release_.Collections.released_questions_paginator = new question_release_.Collections.timeline();
		this._active_tab();
		this.render();
		that = this;
	},
	reset_html_paginator : function(){

		$(".content-questions-stream .no_response").remove();
		$(".paginator-question").remove();

		},

	_active_tab : function(){

		// remove all link tabs active
		$(".link").removeClass("active");
		$(this.tab).addClass("active");

	},
	update_timeline : function(){

			that.reset_html_paginator();
			// uri_status ya contiene la cadena exacta que se va a agregar al final de la url 
			var uri_status_question = config_user.uri_status_question;

			
			//regresamos la path a su estado original

			//uri_status_question es la url que se anarida al final de la url para poder filtrar las preguntas
			// si es la primera ves que se ejecuta este metodo entonces no esta definido uri_status_question y la url esta intacta
			if (uri_status_question == undefined){

				//backup original url
				path_url_original = question_release_.Collections.released_questions.url;
				//uri_status_question is undefined , so put it ""
				uri_status_question = "";

			}else{
				// seunda ves que se ejecuta el metodo entonces reestablecemos la url para evitar que se acumulen parametros de uri_status
				question_release_.Collections.released_questions.url = path_url_original;	
			}

			question_release_.Collections.released_questions.url = question_release_.Collections.released_questions.url+ uri_status_question;


		question_release_.Collections.released_questions.fetch({
		
			beforeSend  : function(){
	
				window.App.PATH = "release";
				that.$el.html(""); // empty container contacts
				$("#loader").show();

			},
			success : function(data){
							

				_.each (data.models , function(question_item){
					that.renderQuestion(question_item);

				});

				$("#loader").hide();
				$(".timeago").timeago();
				$(".contact-str").addClass("fix_conctact_size");
				//decide si agregar el paginator de laas preguntas o no
				that.if_append_paginator(data);
			
					}	
	
		
		});

		},
		append_new_questions_by_paginator : function(){


				var new_url_to_paginate = $(".paginator-question .url-next").attr("next"); 

				console.log("append new questions now ");

				question_release_.Collections.released_questions_paginator.url =   new_url_to_paginate;

				question_release_.Collections.released_questions_paginator.fetch({

				beforeSend  : function(){
		
					$("#loader").show();

				},

				success : function(data){
								
					console.log(data.models)
					console.dir( question_release_.Collections.released_questions_paginator)
					question_release_.Collections.released_questions.add(data.models )
					

					_.each (data.models , function(question_item){
						that.renderQuestion(question_item);

					});

					$("#loader").hide();
					$(".timeago").timeago();

			
					//decide si agregar el paginator de laas preguntas o no
					that.if_append_paginator(data);

					}	
			});
		},
		if_append_paginator : function(data){

				// si el total de las preguntas es mayor que el limite entonces procedemos a sacar las preguntas
				//data.total_count es la cantidad total de las preguntas existentes

				console.log(question_release_.Collections.released_questions.models.length)
				$(".paginator-question").remove();
				if ( data.total_count >  question_release_.Collections.released_questions.models.length ){

						console.log("ahhhh ======>" , data.total_count , data.limit);
						paginator_template = new paginator();
						// antes de llamar a template ponemos nuevas configuraciones al template

						// apuntamos la nueva ruta de paginacion
						paginator_template.next_url = data.next;

						// apuntamos la nueva callback a exec
						paginator_template.callback =  this.append_new_questions_by_paginator;

						//ingresamos el el template el nuevo paginador
						var template_paginator = paginator_template.render().el;
						$(".container[data=dashboard]").find(".content-questions-stream").append(template_paginator);
				}else{

					this.reset_html_paginator();	
					console.log("fin");
					$(".container[data=dashboard]").find(".content-questions-stream").append("<div class='no_response'> No hay mas preguntas y pendientes. </div>");
					this.paginator = false;

				}

		},

	render : function(){
		

		that = this;

		 var filter_button_instance = $("body").data("instance_filter");
		var filter_button = "";	

		
		 
		 if ( filter_button_instance == undefined ){
		 
		 var new_instance_filter = new filters();
		 $("body").data("instance_filter" , new_instance_filter  );

		 filter_button = new_instance_filter;

		 }else{

		filter_button  =  $("body").data("instance_filter");

		 }

		  
		$(".container[data=dashboard]  .filters-container").html(filter_button.render().template );

		filter_button.set_callback = this.update_timeline;

		//-----------------------------------------------------

		this.update_timeline();


		// limit
	}
, renderQuestion : function(question){
			
			
			var question_instance = new instance_question({
				model : question 
			});

			
		this.$el.append(question_instance.render().el);

		}

	});
	

	return question_release_.Views.question_release;
})(require);

});
