define( function(require){

return (function(){
	var $		= require('jquery'),
	    _ 		= require('underscore'),
	    instance_question 	= require('question_timeline'),
	    filters 	= require('filters'),
	    paginator 	= require('paginator'),
	    Backbone    = require('backbone');
	
	var path_url_original = "";

	var own_questions = {

		Views 		: {},
		Models 		:{},
		Collections 	: {}
		}
//--------------------------------------------------------------------------------------------------------- MODEL COLLECTION

		//MODELS 
		own_questions.Models.timeline = Backbone.Model.extend({});
		
		//Collections

		own_questions.Collections.timeline = Backbone.Collection.extend({

			url : "api/v1/pregunta/?for="+config_user.id,

			initialize : function(){


			},
		parse : function(response){
			console.log(response , "=======>");
			this.next = response.meta.next;
			this.total_count = response.meta.total_count;
			this.limit = response.meta.limit;
			this.offset = response.meta.offset;

			return response.objects;
		}
		});
//--------------------------------------------------------------------------------------------------------- VIEW
	//Master View
	own_questions.Views.timeline = Backbone.View.extend({

		el : ".container_questions",
		tab : ".question-timeline-link",

		initialize : function(){
	
		config_user['path'] = 'question_receive'
		// cuando es false ,corta los nombres de los usuarios , true = mostrarlos completos
		config_user['slice_name'] = false;
		// sin url_status al inicial la aplicacion
		config_user["uri_status_question"] =  undefined;
		
		this.reset_html_paginator();
		own_questions.Collections.own_questions_stream = new own_questions.Collections.timeline();
		own_questions.Collections.own_questions_stream_paginator = new own_questions.Collections.timeline();
		this._active_tab();	
		this.render();

		},
		reset_html_paginator : function(){

		$(".content-questions-stream .no_response").remove();
		$(".paginator-question").remove();

		},

		_active_tab : function(){

		$(".link").removeClass("active");

		$(this.tab).addClass("active");

		}, 

		append_new_questions_by_paginator : function(){


				var new_url_to_paginate = $(".paginator-question .url-next").attr("next"); 

				console.log("append new questions now ");

				own_questions.Collections.own_questions_stream_paginator.url =   new_url_to_paginate;

				own_questions.Collections.own_questions_stream_paginator.fetch({

				beforeSend  : function(){
		
					$("#loader").show();

				},

				success : function(data){
								
					console.log(data.models)
					console.dir( own_questions.Collections.own_questions_stream_paginator)
					own_questions.Collections.own_questions_stream.add(data.models )
					

					_.each (data.models , function(question_item){
						that.renderQuestion(question_item);

					});

					$("#loader").hide();
					$(".timeago").timeago();

			
					//decide si agregar el paginator de laas preguntas o no
					that.if_append_paginator(data);

					}	
			});
		},
		if_append_paginator : function(data){

				// si el total de las preguntas es mayor que el limite entonces procedemos a sacar las preguntas
				//data.total_count es la cantidad total de las preguntas existentes

				console.log(own_questions.Collections.own_questions_stream.models.length)
				$(".paginator-question").remove();
				if ( data.total_count >  own_questions.Collections.own_questions_stream.models.length ){

						console.log("ahhhh ======>" , data.total_count , data.limit);
						paginator_template = new paginator();
						// antes de llamar a template ponemos nuevas configuraciones al template

						// apuntamos la nueva ruta de paginacion
						paginator_template.next_url = data.next;

						// apuntamos la nueva callback a exec
						paginator_template.callback =  this.append_new_questions_by_paginator;

						//ingresamos el el template el nuevo paginador
						var template_paginator = paginator_template.render().el;
						$(".container[data=preguntas]").find(".content-questions-stream").append(template_paginator);
				}else{


					this.reset_html_paginator();
					console.log("fin");
					$(".container[data=preguntas]").find(".content-questions-stream").append("<div class='no_response'> No hay mas preguntas y pendientes. </div>");
					this.paginator = false;

				}

		},
		// cada ves que se dispara un evento se actualiza el timeline 
		update_timeline : function(){
		

			that.reset_html_paginator();

			// uri_status ya contiene la cadena exacta que se va a agregar al final de la url 
			var uri_status_question = config_user.uri_status_question;

			console.log(uri_status_question)
			//regresamos la path a su estado original

			//uri_status_question es la url que se anarida al final de la url para poder filtrar las preguntas
			// si es la primera ves que se ejecuta este metodo entonces no esta definido uri_status_question y la url esta intacta
			if (uri_status_question == undefined){

				//backup original url
				path_url_original = own_questions.Collections.own_questions_stream.url;
				//uri_status_question is undefined , so put it ""
				uri_status_question = "";

			}else{
				// seunda ves que se ejecuta el metodo entonces reestablecemos la url para evitar que se acumulen parametros de uri_status
				own_questions.Collections.own_questions_stream.url = path_url_original;	
			}
			

			var new_url_question_stream = own_questions.Collections.own_questions_stream.url;

			own_questions.Collections.own_questions_stream.url =  own_questions.Collections.own_questions_stream.url+ uri_status_question;

		 	own_questions.Collections.own_questions_stream.fetch({

			beforeSend  : function(){
	
				that.$el.html(""); // empty container contacts
				$("#loader").show();

			},

			success : function(data){
							

				//decide si agregar el paginator de laas preguntas o no
				that.if_append_paginator(data);
				

				_.each (data.models , function(question_item){
					that.renderQuestion(question_item);

				});

				$("#loader").hide();
				$(".timeago").timeago();

		

				}	
			});

		},
		render : function(){

		that = this;

		 var filter_button_instance = $("body").data("instance_filter");
		var filter_button = "";	

		
		 console.log(filter_button_instance)
		 if ( filter_button_instance == undefined ){
		 
		 var new_instance_filter = new filters();
		 $("body").data("instance_filter" , new_instance_filter  );

		 filter_button = new_instance_filter;

		 }else{

		filter_button  =  $("body").data("instance_filter");

		 }

		
		$(".filters-container").html(filter_button.render().template );

		filter_button.set_callback = this.update_timeline;

		//-----------------------------------------------------

		this.update_timeline();

		}, renderQuestion : function(question){
			
			
			var question_instance = new instance_question({
				model : question 
			});

			
		this.$el.append(question_instance.render().el);

		}


	});

	return own_questions.Views.timeline;

})(require);


});
