//Objectivo : Proporcionar funcionalidad de buscar usuarios , seleccionar el deseado e insertarlo en un div disfrasado de input,
//	      filtrar usuarios y meter 1:N usuarios en forma de labels , 
define([
  'jquery',
  'underscore',
  'backbone',
  'user_unique',
  ],function($, _ ,Backbone, user_unique ){

return (function(){
	var search_user = {

		Views 		: {},
		Models 		:{},
		Collections 	: {},
		query : "" , 
		}
	
	// si eres admin puedes ver todos los usuarios , si no , solo los que estas suscrito

	var  url_to_get_users = "";
	if(config_user.is == 	"Admin" ){
		
		url_to_get_users = "/api/v1/usuario/?first_name__icontains=";
	}else{

		url_to_get_users = "api/v1/allow_contacts/?user_suscriptor="+config_user.id+"&user_contact=" 
	}


		//MODELS 
		search_user.Models.user_filter= Backbone.Model.extend({});
		//Collections

		search_user.Collections.user_filter = Backbone.Collection.extend({

			model : search_user.Models.user_filter,

			url : url_to_get_users ,  

			initialize : function( models , options){
				this.query = options.query;
				this.url = this.url+ this.query

			},
		parse : function(response){

			return response.objects;
		}
		});

// vista de las label con nombre que seran agregados cuando un enter event sea cachado sobre algun usuario en la lista de Search_user_keyup 


		label_user_added  = Backbone.View.extend({

		});

// Vista de busqueda de usuarios 
		var Search_user_keyup =  Backbone.View.extend({

			template_contact : $("#template-contact").html() , 

			el : '.container-search-user',

			message_no_items : "No hay contactos" , 
			
			container_result_class  : "container-result-filter", // esta solo es la clase que se inyecta en el html

			container_cc_class  : "content-cc-data", // container cc data 

			$container_result : $(".container-result-filter"),  // este es el elemento $ de la clase

			initialize  : function(){
				
					var that = this;
					this.synchronized = true;
					console.log('keyup para busqueda questions');
					this.$el.append('<div class='+this.container_result_class+'></div>');
					this.$el.parent().append('<div class='+this.container_cc_class+'></div>');
					//evento click

					// ponemos a falso el evneto para saber cuando ya se ha ligado un evento a este elemento
					$(".close-element").data("events",false)
				
					// aparte de manejar los eventos del teclado , se manejan los clicks 
					var container_result_filter_childs = $(".container-result-filter").children()
					$(".container-result-filter").on(  "click",'.contact-str',function(){
						$(this).addClass("tab_selected_in_list");
						that._enter_tab();
					});
			},

			events : {
					'keyup input' : 'filter'
				},

			filter: function ( e ){

				/*	keycode para manejar los eventos del teclado 

					38 -> Up
					40 -> down
					37 -> left
					39 -> right
					13 -> enter
					27 -> esc .
				*/
				switch(e.which){

					//arriba
					case 38 : this._up_tab();  break;
					//down
					case 40 : this._down_tab();  break;
					//left
					case 37: this._up_tab(); break;
					//right
					case 39: this._down_tab(); break;
					//enter
					case 13: this._enter_tab();  break;
					//esc
					case 27: this._esc_tab(); break;
					//search
					default: 

				//No pueden reenderear nungun recurso si alguien esta rendereando multipli clicked ajax
					if (this.synchronized ){
						
						this.synchronized = false;
						this._search(e); 
					}

				}
			},
			// filtro la palabra ingresada y buscamos los resultadosd posibles
			_search : function(e){
				
				current_element_selected = 0;
				that = this;
				$(".container-result-filter").html("");
				$(".container-result-filter").hide();
				current_object  =  $(e.currentTarget).parent()
				
				current_object.children(".container-result-filter").html("");
				current_object.children(".container-result-filter").show();
			
				search_user.query = $(e.currentTarget).val() 
				search_user.Collections.get_users = new search_user.Collections.user_filter(null , { query : search_user.query } )
				search_user.Collections.get_users.fetch({
						success : function(data){

							if( data.length != 0){

								_.each(data.models, function(user_item){

									that.renderUser(user_item);

							});

							}else{

						current_object.children(".container-result-filter").html("<span class='message_no_item' >No hay contactos..</span>");

							}
							that.synchronized = true;
							console.log(that.synchronized)
						}
				});


			},// rendereo del usuario
			renderUser : function(user_item){
					
				var user_template_instance = new  user_unique( {
						model : user_item	
				
				})

				console.log(user_template_instance.render().el.outerHTML)
				template_user = user_template_instance.render().el.outerHTML;
				// se activa para el padre actual del evento
				current_object.children(".container-result-filter").append(template_user)

					
			},_enter_tab : function(){
			//obtener el elemento seleccionado
			// cuando entra un enter decide dos cosas
			// 1.- Saber si se quiere insertar el usuario en una lista 1:N div
			// 2.- Saber si se quiere insertar el usuario en el input ( en esta opcion se ingresa la imagen y el nombre en el input" 1:1

		
			// contenedor principal de todo el input input-group
			main_element =	$(".tab_selected_in_list").parent().parent();
			where_to_append = $(main_element).attr('data-append');
			//where_to_append contains div or input at this point
			console.log(where_to_append);
			
			// obtenemos los datos del usuario que se insertaran en su respectivo elemento

			var element_selected  = $(".tab_selected_in_list"); 
			var name = $(element_selected).children(".name").html();
			var id = $(element_selected).children(".name").attr("data-id"); 


			switch(where_to_append){

				case 'div' : this._append_into_div(id, name); break;
				case 'input' : this._append_into_input(); break;
			}
					// cerramos la tab actual
			this._close_tab();


			},
			// se ingresa el usuario seleccionado y se simula que ha sido metido en un input

			_append_into_input : function(){
			
				//apuntamos al container-search-user
				current_object  = $(".tab_selected_in_list").parent().parent();

				//obtenemos el usuario seleccionado
				var element_selected  = $(".tab_selected_in_list"); 

			var name = $(element_selected).children(".name").html();
			var id = $(element_selected).children(".name").attr("data-id"); 
			var img = $(element_selected).children(".img").attr("src"); 

				

				current_user_selected = current_object.find(".tab_selected_in_list");

				//x-field es la clase css que tiene la ui para simular el input
				current_object.append("<div class='x-field'></div> ");

				console.log(element_selected , "elemento a inyectar");
				// insertamos el nuevo elemento en el div
				current_object.find(".x-field").html(element_selected);
				//insertamos boton de cerrar 
				current_object.find(".x-field").append('<span class="close-element">x</span>');

				console.log(current_object.find(".x-field") ) 
				//ocultamos el input real
				current_object.children("input").hide();
				current_object.children("input").val("true");

				// remover la clase del input seleccionado tab_selected_in_list

				element_selected.removeClass("tab_selected_in_list");
				
				//evento click

				if ( !$(".close-element").data("events") ){

					$(".close-element").data("events",true);
					$(".close-element").click(this._close_and_return_input );
				}	
				
			},
			_close_and_return_input : function(){

				console.log("esto pasa")
				current_object  = $(this).parent().parent();
				$(".x-field").remove();
				 current_object.children("input").val(""); 
				 current_object.children("input").show(); 
				 current_object.children("input").focus(); 

			}
			,// ingresamos los nuevos elementos en el div que contiene 1:N elementos 

			//ingresamos labels
			_append_into_div : function(id ,name){
			
			// flag para determinar si existe en la lista de contactos  el elemento que se quiere ingresar
			var element_exist = false;
			//actual cc del elemento input
			current_cc = current_object.parent().children("."+this.container_cc_class);
			// insertarlo en html para que haga funcion de label 
			
			$(current_cc).append(function(){
				
				_.each( current_cc.children() , function(label){
						
						id_element_in_box= ($(label).children().attr('data-id') )
						console.log( id_element_in_box , id ,"aquiii" );
						element_exist  = ( id_element_in_box == id ) ?  true : element_exist;

				});


				// agregamos si el elemento no existe
				if(!element_exist){
					return "<span class='tag label label-info'>"+
				       		"<div data-id="+id+" class='name'>"+name+"<span class='label-close'>x</span></div>"+
				       		"</span>";
				}else{
					return false;
				}
			});
			
			current_object.children("input").val("");
			current_object.children("input").focus();

			//evento click al boton label-close

			$(".label-close").click(this._delete_label);

			},
			_delete_label : function(e){
		
				$(this).parent().parent().remove();

				
			},
			_close_tab : function(){


				current_object.children(".container-result-filter").hide()
				current_object.children(".container-result-filter").html("")


			},
			_esc_tab : function(){
					
				this._close_tab();
			},
			// down
			_down_tab : function(){

					
				// si existen usuarios en la lista entonces si podra bajar con la tecla , si no no podra porque no hay contactos es visible
				if(search_user.Collections.get_users.models.length > 0){

				childs = current_object.children(".container-result-filter").children()
				max_length_childs = childs.length;
				current_element_selected = ( current_element_selected == max_length_childs ) ? 1 : current_element_selected +=1;

				console.log(current_element_selected);
				for(i=0; i< max_length_childs ; i++  ){
					
					$(childs[i]).removeClass("tab_selected_in_list");

					if ( i == current_element_selected - 1 ){
						childs[i].className = childs[i].className+ " tab_selected_in_list";
					}
				}
				}// end if is there models
			},
			// cuando se selecciona alguna tab , se toma el item y se inyecta en el html para simular la seleccion
			_up_tab : function(){

				// si existen usuarios en la lista entonces si podra bajar con la tecla , si no no podra porque no hay contactos es visible
				if(search_user.Collections.get_users.models.length > 0){

				childs = current_object.children(".container-result-filter").children()
				max_length_childs = childs.length;
				current_element_selected = ( current_element_selected == 1 ) ? max_length_childs  : current_element_selected-=1;
				//current_element_selected = ( current_element_selected == max_length_childs ) ? 0 : 

				console.log(current_element_selected);
				for(i=0; i< max_length_childs ; i++  ){
					
					$(childs[i]).removeClass("tab_selected_in_list");

					if ( i == current_element_selected - 1 ){
						childs[i].className = childs[i].className+ " tab_selected_in_list";
					}
				}

			}

			}
			
			}); 

		return Search_user_keyup;

})($, _ ,Backbone,$  ,user_unique );

		
}); 
